// DlgProxy.cpp : implementation file
//

#include "stdafx.h"
#include "SAOpenAuxInst.h"
#include "DlgProxy.h"
#include "SAOpenAuxInstDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CSAOpenAuxInstDlgAutoProxy

IMPLEMENT_DYNCREATE(CSAOpenAuxInstDlgAutoProxy, CCmdTarget)

CSAOpenAuxInstDlgAutoProxy::CSAOpenAuxInstDlgAutoProxy()
{
	EnableAutomation();
	
	// To keep the application running as long as an automation 
	//	object is active, the constructor calls AfxOleLockApp.
	AfxOleLockApp();

	// Get access to the dialog through the application's
	//  main window pointer.  Set the proxy's internal pointer
	//  to point to the dialog, and set the dialog's back pointer to
	//  this proxy.
	ASSERT_VALID(AfxGetApp()->m_pMainWnd);
	if (AfxGetApp()->m_pMainWnd)
	{
		ASSERT_KINDOF(CSAOpenAuxInstDlg, AfxGetApp()->m_pMainWnd);
		if (AfxGetApp()->m_pMainWnd->IsKindOf(RUNTIME_CLASS(CSAOpenAuxInstDlg)))
		{
			m_pDialog = reinterpret_cast<CSAOpenAuxInstDlg*>(AfxGetApp()->m_pMainWnd);
			m_pDialog->m_pAutoProxy = this;
		}
	}
}

CSAOpenAuxInstDlgAutoProxy::~CSAOpenAuxInstDlgAutoProxy()
{
	// To terminate the application when all objects created with
	// 	with automation, the destructor calls AfxOleUnlockApp.
	//  Among other things, this will destroy the main dialog
	if (m_pDialog != NULL)
		m_pDialog->m_pAutoProxy = NULL;
	AfxOleUnlockApp();
}

void CSAOpenAuxInstDlgAutoProxy::OnFinalRelease()
{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.

	CCmdTarget::OnFinalRelease();
}

BEGIN_MESSAGE_MAP(CSAOpenAuxInstDlgAutoProxy, CCmdTarget)
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CSAOpenAuxInstDlgAutoProxy, CCmdTarget)
END_DISPATCH_MAP()

// Note: we add support for IID_ISAOpenAuxInst to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .IDL file.

// {A7A0410C-4373-40B8-854B-7FCF06A7E737}
static const IID IID_ISAOpenAuxInst =
{ 0xA7A0410C, 0x4373, 0x40B8, { 0x85, 0x4B, 0x7F, 0xCF, 0x6, 0xA7, 0xE7, 0x37 } };

BEGIN_INTERFACE_MAP(CSAOpenAuxInstDlgAutoProxy, CCmdTarget)
	INTERFACE_PART(CSAOpenAuxInstDlgAutoProxy, IID_ISAOpenAuxInst, Dispatch)
END_INTERFACE_MAP()

// The IMPLEMENT_OLECREATE2 macro is defined in StdAfx.h of this project
// {7E50FB49-3A7B-401C-B38E-76A22E515E06}
IMPLEMENT_OLECREATE2(CSAOpenAuxInstDlgAutoProxy, "SAOpenAuxInst.Application", 0x7e50fb49, 0x3a7b, 0x401c, 0xb3, 0x8e, 0x76, 0xa2, 0x2e, 0x51, 0x5e, 0x6)


// CSAOpenAuxInstDlgAutoProxy message handlers
