// SAOpenAuxInstDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SAOpenAuxInst.h"
#include "SAOpenAuxInstDlg.h"
#include "DlgProxy.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CSAOpenAuxInstDlg dialog




IMPLEMENT_DYNAMIC(CSAOpenAuxInstDlg, CDialog);

CSAOpenAuxInstDlg::CSAOpenAuxInstDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSAOpenAuxInstDlg::IDD, pParent)
	, m_dAuxData(0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pAutoProxy = NULL;
}

CSAOpenAuxInstDlg::~CSAOpenAuxInstDlg()
{
	// If there is an automation proxy for this dialog, set
	//  its back pointer to this dialog to NULL, so it knows
	//  the dialog has been deleted.
	if (m_pAutoProxy != NULL)
		m_pAutoProxy->m_pDialog = NULL;
}

void CSAOpenAuxInstDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SAOPENINSTCTRL1, mOpenAuxInst);
	DDX_Text(pDX, IDC_AUX_DATA_EDIT, m_dAuxData);
	DDX_Control(pDX, IDC_CONNECT_BUTTON, m_ConnectButton);
	DDX_Control(pDX, IDC_ADD_AUX_BUTTON, m_AddButton);
	DDX_Control(pDX, IDC_SEND_BUTTON, m_SendButton);
}

BEGIN_MESSAGE_MAP(CSAOpenAuxInstDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_CLOSE()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_CONNECT_BUTTON, &CSAOpenAuxInstDlg::OnBnClickedConnectButton)
	ON_BN_CLICKED(IDC_ADD_AUX_BUTTON, &CSAOpenAuxInstDlg::OnBnClickedAddAuxButton)
	ON_BN_CLICKED(IDC_SEND_BUTTON, &CSAOpenAuxInstDlg::OnBnClickedSendButton)
END_MESSAGE_MAP()


// CSAOpenAuxInstDlg message handlers

BOOL CSAOpenAuxInstDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	SetButtonStates(mOpenAuxInst.IsConnected());

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSAOpenAuxInstDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSAOpenAuxInstDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSAOpenAuxInstDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

// Automation servers should not exit when a user closes the UI
//  if a controller still holds on to one of its objects.  These
//  message handlers make sure that if the proxy is still in use,
//  then the UI is hidden but the dialog remains around if it
//  is dismissed.

void CSAOpenAuxInstDlg::OnClose()
{
	if (CanExit())
		CDialog::OnClose();
}

void CSAOpenAuxInstDlg::OnOK()
{
	if (CanExit())
		CDialog::OnOK();
}

void CSAOpenAuxInstDlg::OnCancel()
{
	if (CanExit())
		CDialog::OnCancel();
}

BOOL CSAOpenAuxInstDlg::CanExit()
{
	// If the proxy object is still around, then the automation
	//  controller is still holding on to this application.  Leave
	//  the dialog around, but hide its UI.
	if (m_pAutoProxy != NULL)
	{
		ShowWindow(SW_HIDE);
		return FALSE;
	}

	return TRUE;
}


void CSAOpenAuxInstDlg::OnBnClickedConnectButton()
{
	if (!mOpenAuxInst.PopLogonDialog())
	{
		AfxMessageBox(_T("Unable to connect to SA... start SA and add Open Aux Data Interface to the job"));
	}

	SetButtonStates(mOpenAuxInst.IsConnected());
}

void CSAOpenAuxInstDlg::SetButtonStates(const bool IsConnected)
{
	m_ConnectButton.EnableWindow(!IsConnected);
	m_AddButton.EnableWindow(IsConnected);
	m_SendButton.EnableWindow(IsConnected);
	UpdateData(FALSE);
}

void CSAOpenAuxInstDlg::OnBnClickedAddAuxButton()
{
	mOpenAuxInst.ClearAuxiliaryData();
	UpdateData(TRUE);
	mOpenAuxInst.AddAuxiliaryDataItem(_T("TestPt1"),m_dAuxData,_T("Inches"));
	UpdateData(FALSE);
}

void CSAOpenAuxInstDlg::OnBnClickedSendButton()
{
	mOpenAuxInst.SendAuxiliaryData(_T("TestCollection1"),_T("TestGrp1"),_T("TestPt1"));
	mOpenAuxInst.ClearAuxiliaryData();
}
